//+------------------------------------------------------------------+
//|                                                 test clavier.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window

#include <Canvas/Canvas.mqh>

CCanvas canvas_01,canvas_02;


long abc=0;
string obj_name_01;
bool on=false;
char work=0;
int obj_posx_02=0; // save & calulate difference cursor & object corner
int obj_posy_02=0;
int infoOnlyEraseIt_x=0;
int infoOnlyEraseIt_y=0;

double ysin01=0; //new
double xcos01=0; //new
bool b_OnInit=0; //new
extern color obj_color_01=clrOrange;
extern int obj_x_start;
extern int obj_y_start;
int obj_xx_start=200;
int obj_yy_start=200;
int kk=255;
string obj_keep_ress_01;
int temp;

void f_comment()
   {

      Comment(
              "\n\n  obj_name = "+(string)obj_name_01+
              "\n\n  infoOnlyEraseIt_x = "+(string)infoOnlyEraseIt_x+
              "\n\n  infoOnlyEraseIt_y = "+(string)infoOnlyEraseIt_y+
              "\n\n  obj_posx_02 = "+(string)obj_posx_02+
              "\n\n  obj_posy_02 = "+(string)obj_posy_02+
              "\n\n  kk = "+(string)kk+
              "\n\n  ressourceName = "+(string)canvas_01.ResourceName()+
              "\n\n  obj_x_star = "+(string)obj_x_start+
              "\n\n  obj_y_star = "+(string)obj_y_start+
              "\n\n  obj_keep_ress_01 = "+(string)obj_keep_ress_01+
              "\n\n  temp = "+(string)temp
              
              );     
   }



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   EventSetMillisecondTimer(100);
   ChartSetInteger(ChartID(),CHART_EVENT_MOUSE_MOVE,1); //l'event sur OnChartEvent() = ON

   if(b_OnInit==0)
   {
   
   
   //ChartSetInteger(ChartID(),CHART_EVENT_OBJECT_CREATE,1);// l'event sur OnChartEvent() = ON
   

   
   canvas_01.CreateBitmapLabel(ChartID(),0,"test01",obj_x_start,obj_y_start,obj_x_start+100,obj_y_start+100,COLOR_FORMAT_ARGB_NORMALIZE);            
   canvas_01.Erase(ColorToARGB(obj_color_01,128));
   canvas_01.Update();
   
   b_OnInit=0; 
   }



   return(INIT_SUCCEEDED);
  }
  
void OnDeinit(const int reason)
  {
    //canvas_01.Destroy();
    EventKillTimer();
   //b_OnInit=0;
  
  /* if(reason==REASON_RECOMPILE)
   {
    
    Comment("");
    
    //Print("REASON = "+(string)reason);
   }
   
   //ChartSetInteger(ChartID(),CHART_EVENT_MOUSE_MOVE,0); //l'event sur OnChartEvent() = ON
  */ 
   if(reason==REASON_CHARTCHANGE)
   {
   


    Print("REASON_CHARTCHANGE");
    
   }
   

   if(reason==REASON_PARAMETERS)
   {
    
    //canvas_01.Erase(ColorToARGB(obj_color_01,128));
    //canvas_01.Update();
    //b_OnInit=0;
    //Print("REASON = "+(string)reason+"   "+(string)obj_color_01);
   }
   
   temp=100;
   //canvas_01.Destroy();

   Print("REASON = "+(string)reason+"   "+(string)obj_color_01+"   "+(string)ObjectFind(ChartID(),"test01"));
  } 

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

    //Print("color = "+(string)obj_color_01);


   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
   

    //f_comment();
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
   //--- the key has been pressed 
   if(id==CHARTEVENT_KEYDOWN) 
     { 
    /*  switch(int(lparam)) 
        { 
         case KEY_LEFT:          if(pos_x1>0){pos_x1=pos_x1-1;}                    break; 
         case 32:            if(pos_x1>0){pos_x1=pos_x1-1;}                    break; 
         case KEY_RIGHT:         if(pos_x1<200){pos_x1=pos_x1+1;}                  break; 
         case KEY_DOWN:          if(pos_x1<200){pos_x1=pos_x1+1;}                  break; 
        }*/
        //temp_lparam=lparam;
        //f_redrawObject();
        //f_comment();
      //ChartRedraw(); 
     }
    
  if(id==CHARTEVENT_OBJECT_CLICK)
  {
   if(work==0 && sparam=="test01")
   {
    obj_name_01=sparam;
    obj_posx_02=(int)lparam-(int)ObjectGetInteger(ChartID(),obj_name_01,OBJPROP_XDISTANCE);
    obj_posy_02=(int)dparam-(int)ObjectGetInteger(ChartID(),obj_name_01,OBJPROP_YDISTANCE);
    work=1;
    on=true;
   }else if(work==1 && sparam=="test01")
          {
           work=0;
           on=false;          
          }  
  }
  
  if(id==CHARTEVENT_MOUSE_MOVE)
  {
   kk=kk-1;
   if(kk<0)
   {kk=255;}

   
   if(on==true)
   {  
    ObjectSetInteger(ChartID(),obj_name_01,OBJPROP_XDISTANCE,(int)lparam-obj_posx_02);
    ObjectSetInteger(ChartID(),obj_name_01,OBJPROP_YDISTANCE,(int)dparam-obj_posy_02);
    // ********** only for informations, erase it !!
    infoOnlyEraseIt_x=(int)lparam-obj_posx_02;
    infoOnlyEraseIt_y=(int)dparam-obj_posy_02;
    
    obj_x_start=infoOnlyEraseIt_x;
    obj_y_start=infoOnlyEraseIt_y;

    
   }
   // canvas_01.Erase(ColorToARGB(kk,128));
   //canvas_01.Update();
  
   
  //ObjectSetInteger(0,obj_name_01,OBJPROP_COLOR,ColorToARGB(kk,255));
  }
  
  
  
  
  f_comment();
}  